<?php
namespace Claromentis\Core\User\Directory;

$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] ?: array()) + array("opti" . "ons" => base64_decode("b3B0aW9ucw" . "=="), "_3bc8ccbfa" . "87dde17833" . "0887eeef2f" . "c5e" => base64_decode("RGlyZWN0" . "b3J5IHdp" . "dGggaWQg"), "_d1d997d6b7fdc02cc83b4b996482c6" . "3a" => base64_decode("MA=" . "="), "t" . "y" . "p" . "e" => base64_decode("dH" . "lw" . "ZQ" . "=="), "_7f628626dd1d55c71b1fc0932" . "ffd1d2c" => base64_decode("aXNfY" . "XJyYX" . "k="), "_87da279507cfe99829e40" . "eca558cf7d1" => base64_decode("IGRvZXNuJ3Qg" . "ZXhpc3QgLSBj" . "YW4ndCB1cGRh" . "dGU="), "_99cee2d2272a8550f4b21e3cb57" . "fff7d" => base64_decode("ZW5hYmxlZA" . "=="));
use Claromentis\Core\Config\Config;
use Claromentis\Core\User\Directory\Exception\UnknownDirectoryException;




class DirectoriesList
{
    protected Config $storage;
    protected string $variable_name;
    public function __construct(Config $storage, $_af1ebf352fcd1d2906ecd42ae1cde56e)
    {
        $this->storage = $storage;
        $this->variable_name = $_af1ebf352fcd1d2906ecd42ae1cde56e;
    }
    
    
    
    
    public function GetAll() : array
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->storage->get($this->variable_name);
        return $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_7f628626dd1d55c71b1fc0932" . "ffd1d2c"]($_1ac0335a1f605e216d9ffde5545a81e3) ? $_1ac0335a1f605e216d9ffde5545a81e3 : [];
    }
    
    
    
    
    
    
    
    
    
    public function GetAllEnabled() : array
    {
        $_d00c9bfa132c9b19f21346632ca3484c = [];
        $_4a1e36876b85dbb4c5d96e6d097ab404 = $this->GetAll();
        foreach ($_4a1e36876b85dbb4c5d96e6d097ab404 as $_40421a4e75c2ba3c82b018e6b56f7425 => $_d9dec3fec40d714836246e2dbbaa7deb) {
            if ($_40421a4e75c2ba3c82b018e6b56f7425 != $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_d1d997d6b7fdc02cc" . "83b4b996482c63a"]) {
                
                
                if ($_d9dec3fec40d714836246e2dbbaa7deb[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["opti" . "ons"]][$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_99cee2d2272a8550f4b21e3cb5" . "7fff7d"]]) {
                    
                    
                    $_d00c9bfa132c9b19f21346632ca3484c[$_40421a4e75c2ba3c82b018e6b56f7425] = $_d9dec3fec40d714836246e2dbbaa7deb;
                }
            }
        }
        return $_d00c9bfa132c9b19f21346632ca3484c;
    }
    
    
    
    
    
    
    
    public function Add(string $type, array $options) : string
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->GetAll();
        $key = \CryptUtils::GetRandomString(20);
        $_1ac0335a1f605e216d9ffde5545a81e3[$key] = [$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["ty" . "pe"] => $type, $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["optio" . "ns"] => $options];
        $this->SaveAll($_1ac0335a1f605e216d9ffde5545a81e3);
        return $key;
    }
    public function GetByKey(string $key) : ?array
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->GetAll();
        return isset($_1ac0335a1f605e216d9ffde5545a81e3[$key]) ? $_1ac0335a1f605e216d9ffde5545a81e3[$key] : null;
    }
    
    
    
    
    
    
    
    public function Update(string $key, array $options)
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->GetAll();
        if (!isset($_1ac0335a1f605e216d9ffde5545a81e3[$key])) {
            throw new UnknownDirectoryException($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_3bc8ccbfa87dde17" . "8330887eeef2fc5e"] . $key . $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_87da279507cfe99829e40e" . "ca558cf7d1"]);
        }
        $_1ac0335a1f605e216d9ffde5545a81e3[$key][$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["opti" . "ons"]] = $options;
        $this->SaveAll($_1ac0335a1f605e216d9ffde5545a81e3);
    }
    public function Delete(string $key)
    {
        $_1ac0335a1f605e216d9ffde5545a81e3 = $this->GetAll();
        if (!isset($_1ac0335a1f605e216d9ffde5545a81e3[$key])) {
            return;
        }
        unset($_1ac0335a1f605e216d9ffde5545a81e3[$key]);
        $this->SaveAll($_1ac0335a1f605e216d9ffde5545a81e3);
    }
    protected function SaveAll(array $_1ac0335a1f605e216d9ffde5545a81e3)
    {
        $this->storage->set($this->variable_name, $_1ac0335a1f605e216d9ffde5545a81e3);
        $this->storage->save();
    }
    
    
    
    
    public function DirectoriesAreInUse() : bool
    {
        return !empty($this->GetAllEnabled());
    }
}